;-- TIME_STAMP   2021-01-14 04:45:00   v 0.1

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <Array.au3>
;~ #include <Debug.au3>
#include <GuiEdit.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <Timers.au3>
#include <WinAPIGdi.au3>; _WinAPI_RedrawWindow
;~ #include <WinAPISysWin.au3>; _WinAPI_UpdateWindow

;~ #include <_GUICtrlGetFont.au3>
#include "Include\_GUICtrlGetFont.au3"


Opt('MustDeclareVars', 1)

;~ Exit ConsoleWrite(_GetItemStateStr(0x0051) & @CRLF)
;~ Exit _GetEditStyles()

Global $g_bDebug = False

Global Const $tagFIXEDNMLVKEYDOWN = $tagNMHDR & ";word VKey;uint Flags"

Global $g_hGUI, $g_idListView, $g_hListView, $g_idWinSize, $g_aLV_ClientSize, $g_hHeader, $g_aHeaderRect, $g_idEdit, $g_hEdit, $g_hDC, $g_hBrush, $g_hBrush1, $g_hBrush2, $g_iItem = -1, $g_iSubItem = 0, $g_aLVColWidth[4], $g_aRect[4]

Global $g_bEditMode = False, $g_bRECT_OUT_OF_RANGE = False, $g_bRedrawFrameRect = False

Global $g_idEnterDummy, $g_idESCDummy, $g_idPrintSeparatorLine, $g_idRedrawFrameRect

_Main()

Func _Main()
	$g_hGUI = GUICreate("ListView edit all items in place", 340, 250, -1, -1, -1, $WS_EX_TOPMOST)
;~ 	$g_hGUI = GUICreate("ListView edit all items in place", 540, 250, -1, -1, -1, $WS_EX_TOPMOST)
	GUISetFont(12)

	$g_idEnterDummy = GUICtrlCreateDummy()
	$g_idESCDummy = GUICtrlCreateDummy()
	$g_idPrintSeparatorLine = GUICtrlCreateDummy()
	$g_idRedrawFrameRect = GUICtrlCreateDummy()
	Local $aAccelKeys[4][2] = [["{ENTER}", $g_idEnterDummy], ["{ESC}", $g_idESCDummy], ['{F5}', $g_idPrintSeparatorLine], ['{F6}', $g_idRedrawFrameRect]]
	If Not GUISetAccelerators($aAccelKeys, $g_hGUI) Then Exit MsgBox(64, $g_hGUI, 'Error by GUISetAccelerators !!!')

	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	; _GUICtrlListView_Create ( $hWnd, $sHeaderText, $iX, $iY [, $iWidth = 150 [, $iHeight = 150 [, $iStyle = 0x0000000D [, $iExStyle = 0x00000000 [, $bCoInit = False]]]]] )
	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	; Style
	; 	Default (-1) : $LVS_REPORT, $LVS_SINGLESEL, $LVS_SHOWSELALWAYS
	; 	Forced       : $WS_CHILD, $WS_VISIBLE
	; ExStyle
	; 	Default: None
	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;~ $g_hListView = _GUICtrlListView_Create($g_hGUI, "Items|SubItems", 2, 2, 296, 196, BitOR($LVS_EDITLABELS, $LVS_REPORT))
;~ $g_hListView = _GUICtrlListView_Create($g_hGUI, "Items|SubItems", 2, 2, 296, 196, $LVS_REPORT)
;~ $g_idListView = _WinAPI_GetDlgCtrlID($g_hListView)
;~ ConsoleWrite('ExStyle = 0x' & Hex(_GUICtrlListView_GetExtendedListViewStyle($g_hListView)) & @CRLF)
;~ ConsoleWrite('ExStyle = 0x' & Hex(_WinAPI_GetWindowLong($g_hListView, $GWL_EXSTYLE)) & @CRLF)
;~ Exit

	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	; GUICtrlCreateListView ( "text", left, top [, width [, height [, style = -1 [, exStyle = -1]]]] )
	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	; Style
	; 	Default (-1) : $LVS_SHOWSELALWAYS, $LVS_SINGLESEL
	; 	Forced       : $LVS_REPORT
	; ExStyle
	; 	Default (-1) : $LVS_EX_FULLROWSELECT, $WS_EX_CLIENTEDGE
	; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	$g_idListView = GUICtrlCreateListView("Items|SubItems I|SubItems II|SubItems III", 2, 22, 336, 196)
;~ 	$g_idListView = GUICtrlCreateListView("Items|SubItems I|SubItems II|SubItems III", 2, 22, 536, 196)
	$g_hListView = GUICtrlGetHandle($g_idListView)
	$g_aLV_ClientSize = WinGetClientSize($g_hListView)

;~ 	ConsoleWrite('ExStyle = 0x' & Hex(_GUICtrlListView_GetExtendedListViewStyle($g_hListView)) & @CRLF)
;~ 	ConsoleWrite('ExStyle = 0x' & Hex(_WinAPI_GetWindowLong($g_hListView, $GWL_EXSTYLE)) & @CRLF)

;~ 	GUICtrlSetFont($g_idListView, 11)

	_GUICtrlListView_SetExtendedListViewStyle($g_hListView, BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES, $LVS_EX_BORDERSELECT))

	$g_aLVColWidth[0] = _GUICtrlListView_GetColumnWidth($g_hListView, 0)
	$g_aLVColWidth[1] = _GUICtrlListView_GetColumnWidth($g_hListView, 1)
	$g_aLVColWidth[2] = _GUICtrlListView_GetColumnWidth($g_hListView, 2)
	$g_aLVColWidth[3] = _GUICtrlListView_GetColumnWidth($g_hListView, 3)
	Local $iLVColWidth, $hImage = _GUIImageList_Create(16, 16)
	For $i = -16 To -13 Step 1
		_GUIImageList_AddIcon($hImage, "shell32.dll", $i, True)
	Next
	_GUICtrlListView_SetImageList($g_hListView, $hImage, 1)	; small icons

	For $i = 0 To 24
		_GUICtrlListView_AddItem($g_hListView, "Item " & $i, 0)
		$iLVColWidth = _GUICtrlListView_GetStringWidth($g_hListView, "Item " & $i)
		If $iLVColWidth > $g_aLVColWidth[0] Then $g_aLVColWidth[0] = $iLVColWidth

		_GUICtrlListView_AddSubItem($g_hListView, $i, "SubItem " & $i, 1, 1)
		$iLVColWidth = _GUICtrlListView_GetStringWidth($g_hListView, "SubItem " & $i)
		If $iLVColWidth > $g_aLVColWidth[1] Then $g_aLVColWidth[1] = $iLVColWidth

		_GUICtrlListView_AddSubItem($g_hListView, $i, "SubItem " & $i, 2, 2)
		$g_aLVColWidth[3] = _GUICtrlListView_GetStringWidth($g_hListView, "SubItem " & $i)
		If $iLVColWidth > $g_aLVColWidth[2] Then $g_aLVColWidth[2] = $iLVColWidth

		_GUICtrlListView_AddSubItem($g_hListView, $i, "SubItem " & $i, 3, 3)
		$iLVColWidth = _GUICtrlListView_GetStringWidth($g_hListView, "SubItem " & $i)
		If $iLVColWidth > $g_aLVColWidth[3] Then $g_aLVColWidth[3] = $iLVColWidth
	Next

	_GUICtrlListView_SetItemIndent($g_hListView, 0, 1)
	_GUICtrlListView_SetItemIndent($g_hListView, 1, 2)

	_GUICtrlListView_SetColumnWidth($g_hListView, 0, $g_aLVColWidth[0] + 32 + _GUICtrlListView_GetItemIndent($g_hListView, 1) * 16)
	_GUICtrlListView_SetColumnWidth($g_hListView, 1, $g_aLVColWidth[1] + 32)
	_GUICtrlListView_SetColumnWidth($g_hListView, 2, $g_aLVColWidth[2] + 32)
	_GUICtrlListView_SetColumnWidth($g_hListView, 3, $g_aLVColWidth[3] + 32)

	$g_hHeader = _GUICtrlListView_GetHeader($g_hListView)
	$g_aHeaderRect = _GUICtrlHeader_GetItemRect($g_hHeader, 0)
	_DebugPrint('$g_aHeaderRect: ' & _NumArrayOrStructToStrFormat($g_aHeaderRect) & @CRLF)

;~ 	Enlarge window, Reduce window
;~ 	2, 22, 336, 196
	Local $aCS = WinGetClientSize($g_hGUI)
	$g_idWinSize = GUICtrlCreateButton('Enlarge window', 1, $aCS[1] - 31, $aCS[0] - 2)

;~ 	$WS_OVERLAPPED ($WS_TILED), $WS_CLIPSIBLINGS, $WS_VISIBLE, $WS_CHILD ($WS_CHILDWINDOW), $ES_LEFT, $ES_AUTOHSCROLL
;~ 	$g_idEdit = GUICtrlCreateInput('', 0, 0, 0, 0, -1, $WS_EX_TOPMOST)
	$g_idEdit = GUICtrlCreateInput('', 0, 0, 0, 0, BitOR($ES_LEFT, $ES_AUTOHSCROLL))
	$g_hEdit = GUICtrlGetHandle($g_idEdit)
	GUICtrlSetBkColor(-1, 0x20B2AA)
	Local $aFont = _GUICtrlGetFont($g_hListView)
	; [0] - FontSize (~ approximation)
	; [1] - Font weight (400 = normal).
	; [2] - italic:2 underlined:4 strike:8 char format (styles added together, 2+4 = italic and underlined).
	; [3] - The name of the font to use.
	; [4] - Font quality to select (PROOF_QUALITY=2 is default in AutoIt).

	GUICtrlSetFont(-1, $aFont[0] - 0.5, $aFont[1], $aFont[2], $aFont[3], $aFont[4])
	GUICtrlSetState(-1, $GUI_HIDE)
	_WinAPI_SetWindowLong($g_hEdit, $GWL_HWNDPARENT, $g_hListView)

;~ 	$g_hDC = _WinAPI_GetWindowDC($g_hListView) ; Retrieves the device context (DC) for the entire window
	$g_hDC = _WinAPI_GetDC($g_hListView) ; Retrieves a handle of a display device context for the client area a window
	$g_hBrush1 = _WinAPI_CreateSolidBrush(0xFF901E)  ; Dodger Blue (BGR)
	$g_hBrush2 = _WinAPI_CreateSolidBrush(0x007EFF)  ; Amber (BGR)
	$g_hBrush = $g_hBrush1

	GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
	GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")

	GUISetState(@SW_SHOW, $g_hGUI)
	Local $aFont = _GUICtrlGetFont($g_hListView)
;~ 	ConsoleWrite(_ArrayToString($aFont, ', ') & ' err: ' & @error & @CRLF)
;~ 	Exit

	Local $idTimer = _Timer_SetTimer($g_hGUI, 250, '_RedrawFrameRect')

	Local $aRect = _GUICtrlListView_GetItemRect($g_hListView, 0, 2)
	_DebugPrint('$aRect Item      = ' & _ArrayToString($aRect, ', ') & @CRLF)
;~ 	_FrameRect($g_hDC, $aRect) ; OK
	$aRect = _GUICtrlListView_GetSubItemRect($g_hListView, 0, 1)
	_DebugPrint('$aRect SubItem 1 = ' & _ArrayToString($aRect, ', ') & @CRLF & @CRLF)
;~ 	_FrameRect($g_hDC, $aRect) ; OK
	$aRect = _GUICtrlListView_GetSubItemRect($g_hListView, 0, 2)
	_DebugPrint('$aRect SubItem 2 = ' & _ArrayToString($aRect, ', ') & @CRLF & @CRLF)

;~ 	_FrameRect($g_hDC, $aRect) ; OK

	Local $sFocus, $sOldFocus, $aCursorInfo, $aRect, $hOldBrush = -1, $iEnlarge = 16
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $g_idWinSize
				Local $iSize = StringLeft(GUICtrlRead($g_idWinSize), 7) = 'Enlarge' ? $iEnlarge : 12
				ConsoleWrite('Case $g_idWinSize $iSize: ' & $iSize & @CRLF)

				GUICtrlSetData($g_idWinSize, $iSize = $iEnlarge ? 'Reduce window' : 'Enlarge window')
				Local $aPos = WinGetPos($g_hGUI)
				$aPos[0] += $iSize = $iEnlarge ? -100 : +100
				WinMove($g_hGUI, '', $aPos[0], $aPos[1], $iSize = $iEnlarge ? 540 : 340, 250)
				GUISetFont($iSize)
				GUICtrlSetFont($g_idListView, $iSize)
				GUICtrlSetFont($g_idEdit, $iSize - 0.5)
				GUICtrlSetFont($g_idWinSize, $iSize)
				$aCS = WinGetClientSize($g_hGUI)
				GUICtrlSetPos($g_idWinSize, 2, $aCS[1] - ($iSize = $iEnlarge ? 30 : 30), $aCS[0] - 4)

			Case Else
				If $g_bEditMode Then
					$aCursorInfo = GUIGetCursorInfo($g_hGUI)
					$g_hBrush = $aCursorInfo[4] = $g_idEdit ? $g_hBrush2 : $g_hBrush1
					If $g_hBrush <> $hOldBrush Then
						$hOldBrush = $g_hBrush
						$aRect = _GetEditRect($g_iItem, $g_iSubItem)
						_DebugPrint('> _Main: _FrameRect $g_hBrush: ' & ($g_hBrush = $g_hBrush1 ? '$g_hBrush1' : '$g_hBrush2') & @CRLF)
						_FrameRect($g_hDC, $aRect, $g_hBrush)
					EndIf
				EndIf

				$sFocus = ControlGetFocus($g_hGUI)
				If $sFocus <> $sOldFocus Then
					$sOldFocus = $sFocus
;~ 					_DebugPrint('! $sFocus = ' & $sFocus & @CRLF)
					_DebugPrint('! _Main: $sFocus = ' & $sFocus & @CRLF)
				EndIf
		EndSwitch
	WEnd
	ConsoleWrite('Huhu' & @CRLF)

	_Timer_KillTimer($g_hGUI, $idTimer)
	_WinAPI_DeleteObject($g_hBrush1)
	_WinAPI_DeleteObject($g_hBrush2)
	_WinAPI_ReleaseDC($g_hListView, $g_hDC)
EndFunc   ;==>_Main

; Message Source 	wParam (high word) 					wParam (low word) 				lParam
; Menu 				0 									Menu identifier (IDM_*) 		0
; Accelerator 		1 									Accelerator identifier (IDM_*) 	0
; Control 			Control-defined notification code 	Control identifier 				Handle to the control window
Func WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
	_DebugPrint('> WM_COMMAND('&$hWnd&', '&$iMsg&', '&$wParam&', '&$lParam&')' & @CRLF)
	#forceref $hWnd, $iMsg
	Local $hWndFrom, $iIDFrom, $iCode, $sText, $sFocus
	$hWndFrom = $lParam
	$iIDFrom = BitAND($wParam, 0xFFFF) ; Low Word
	$iCode = BitShift($wParam, 16)     ; Hi Word

	Switch $iCode
		Case 0 ; Menu
			_DebugPrint('! WM_COMMAND: Case 0 $iCode: ' & $iCode & '(Menu)        $iIDFrom: ' & $iIDFrom & @CRLF)
		Case 1 ; Accelerator
			_DebugPrint('! WM_COMMAND: Case 0 $iCode: ' & $iCode & '(Accelerator) $iIDFrom: ' & $iIDFrom & @CRLF)
			If $iIDFrom = $g_idESCDummy Then
				If Not $g_bEditMode Then Exit
				_SwitchEditState(False)
			ElseIf $iIDFrom = $g_idEnterDummy Then
				If $g_bEditMode Then
					$sText = _GUICtrlEdit_GetText($g_hEdit)
					If $sText <> _GUICtrlListView_GetItemText($g_hListView, $g_iItem, $g_iSubItem) Then
						_GUICtrlListView_SetItemText($g_hListView, $g_iItem, $sText, $g_iSubItem)
					EndIf
					_SwitchEditState(False)
				EndIf
			ElseIf $iIDFrom = $g_idPrintSeparatorLine Then
				ConsoleWrite('------------------------------------------------------------------------' & @CRLF)
			ElseIf $iIDFrom = $g_idRedrawFrameRect Then
;~ 				Local $aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
				Local $aRect = _GetEditRect($g_iItem, $g_iSubItem)
				_FrameRect($g_hDC, $aRect, $g_hBrush)
			EndIf
		Case Else ; Control-defined notification code
			_DebugPrint('! WM_COMMAND: Case 0 $iCode: ' & $iCode & '(Control)     $iIDFrom: ' & $iIDFrom  & ' $hWndFrom: ' & $hWndFrom & @CRLF)
			Switch $hWndFrom
				Case $g_hEdit
					Switch $iCode
						Case $EN_KILLFOCUS
							$sFocus = ControlGetFocus($g_hGUI)
							_DebugPrint('! WM_COMMAND: Case $EN_KILLFOCUS Focus: ' & $sFocus & ' $g_bRECT_OUT_OF_RANGE: ' & $g_bRECT_OUT_OF_RANGE & @CRLF)
							If $sFocus <> '' And $g_bRECT_OUT_OF_RANGE = False Then
								; Folgende Zeilen aktivieren, wenn der Text bei $EN_KILLFOCUS übernommen werden soll.
;~ 								$sText = _GUICtrlEdit_GetText($g_hEdit)
;~ 								If $sText And $sText <> _GUICtrlListView_GetItemText($g_hListView, $g_iItem, $g_iSubItem) Then
;~ 									_GUICtrlListView_SetItemText($g_hListView, $g_iItem, $sText, $g_iSubItem)
;~ 								EndIf

								_SwitchEditState(False)
							EndIf
					EndSwitch
			EndSwitch
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_COMMAND

#Tidy_Off
Func WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam
	Local $tNMHDR, $hWndFrom, $iIDFrom, $iCode
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = DllStructGetData($tNMHDR, "hWndFrom")
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")
	Switch $hWndFrom
		Case $g_hListView
			Local $tNMLVSCROLL, $iDX, $iDY
			Switch $iCode
				Case $LVN_ITEMACTIVATE   ; -114 Sent by a list-view control when the user activates an item.
					_DebugPrint('! WM_NOTIFY: Case $LVN_ITEMACTIVATE' & @CRLF)
;~ 					Local $tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $lParam)

					Return 0
					; The application receiving this notification code must return zero.
				Case $LVN_ITEMCHANGED    ; -101 Notifies a list-view control's parent window that an item has changed.
					Local $tNMLISTVIEW, $iItem, $iSubItem, $aInfo, $aHit, $iNewState, $iOldState

					$tNMLISTVIEW = DllStructCreate($tagNMLISTVIEW, $lParam)
					$iItem = DllStructGetData($tNMLISTVIEW, "Item")
					$iSubItem = DllStructGetData($tNMLISTVIEW, "SubItem")
					$iNewState = DllStructGetData($tNMLISTVIEW, "NewState")
					$iOldState = DllStructGetData($tNMLISTVIEW, "OldState")

					_DebugPrint("WM_NOTIFY $LVN_ITEMCHANGED" & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode & @CRLF & _
							"--> Item    : " & DllStructGetData($tNMLISTVIEW, "Item") & @CRLF & _
							"--> SubItem : " & DllStructGetData($tNMLISTVIEW, "SubItem") & @CRLF & _
							"--> NewState: " & DllStructGetData($tNMLISTVIEW, "NewState") & _GetItemStateStr($iNewState) & @CRLF & _
							"--> OldState: " & DllStructGetData($tNMLISTVIEW, "OldState") & _GetItemStateStr($iOldState) & @CRLF & _
							"--> Changed : " & DllStructGetData($tNMLISTVIEW, "Changed") & @CRLF & _
							"--> ActionX : " & DllStructGetData($tNMLISTVIEW, "ActionX") & @CRLF & _
							"--> ActionY : " & DllStructGetData($tNMLISTVIEW, "ActionY") & @CRLF & _
							"--> Param   : " & DllStructGetData($tNMLISTVIEW, "Param"))

					If $g_iItem > -1 Then _GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
					$g_iItem = $iItem
					$g_iSubItem = $iSubItem

					_DebugPrint('_GUICtrlListView_SetItemSelected($g_hListView, $iItem ('&$iItem&'), False)' & @CRLF)
					_GUICtrlListView_SetItemSelected($g_hListView, $iItem, False)

					; No return value.
				Case $LVN_ITEMCHANGING   ; -100 Notifies a list-view control's parent window that an item is changing.
					Local $tNMLISTVIEW, $iItem, $aInfo, $aHit

					$tNMLISTVIEW = DllStructCreate($tagNMLISTVIEW, $lParam)
					$iItem = DllStructGetData($tNMLISTVIEW, "Item")

					_DebugPrint("WM_NOTIFY $LVN_ITEMCHANGING" & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode & @CRLF & _
							"--> Item    : " & DllStructGetData($tNMLISTVIEW, "Item") & @CRLF & _
							"--> SubItem : " & DllStructGetData($tNMLISTVIEW, "SubItem") & @CRLF & _
							"--> NewState: " & DllStructGetData($tNMLISTVIEW, "NewState") & @CRLF & _
							"--> OldState: " & DllStructGetData($tNMLISTVIEW, "OldState") & @CRLF & _
							"--> Changed : " & DllStructGetData($tNMLISTVIEW, "Changed") & @CRLF & _
							"--> ActionX : " & DllStructGetData($tNMLISTVIEW, "ActionX") & @CRLF & _
							"--> ActionY : " & DllStructGetData($tNMLISTVIEW, "ActionY") & @CRLF & _
							"--> Param   : " & DllStructGetData($tNMLISTVIEW, "Param"))
					Return False
					; Returns TRUE to prevent the change, or FALSE to allow the change.
				Case $LVN_BEGINSCROLL    ; -180
;~ 					Return
					If $g_bEditMode Then
;~ 						Local $aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
						Local $aRect = _GetEditRect($g_iItem, $g_iSubItem)
						Local $iTopIndex = _GUICtrlListView_GetTopIndex($g_hListView)
						Local $iCounterPage = _GUICtrlListView_GetCounterPage($g_hListView)
						Local $sColor
						$tNMLVSCROLL = DllStructCreate($tagNMLVSCROLL, $lParam) ; Pointer to a NMLVSCROLL structure that contains the horizontal or vertical position of where the scroll operation starts.
						$iDX = DllStructGetData($tNMLVSCROLL, 'DX')
						$iDY = DllStructGetData($tNMLVSCROLL, 'DY')
						If $iDX Or $iDY Then
							$sColor = '>'
						Else
							$sColor = '!'
						EndIf
						_DebugPrint($sColor  & ' WM_NOTIFY $LVN_BEGINSCROLL $iTopIndex: ' & $iTopIndex & ' $iCounterPage: ' & $iCounterPage & ' $iDX: ' & $iDX & ' $iDY: ' & $iDY & _
								' $g_iItem: ' & $g_iItem & ' $g_iSubItem: ' & $g_iSubItem & ' (' & $g_iItem - $iDY & ')' & _
								' $aRect: ' & _NumArrayOrStructToStrFormat($aRect) & ' $g_bEditMode: ' & $g_bEditMode & @CRLF)
					EndIf
					; Return value not used.
				Case $LVN_ENDSCROLL      ; -181
					If $g_bEditMode Then
;~ 						$g_aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
						$g_aRect = _GetEditRect($g_iItem, $g_iSubItem)
						Local $iTopIndex = _GUICtrlListView_GetTopIndex($g_hListView)
						Local $iCounterPage = _GUICtrlListView_GetCounterPage($g_hListView)
						Local $sColor
						$tNMLVSCROLL = DllStructCreate($tagNMLVSCROLL, $lParam) ; Pointer to a NMLVSCROLL structure that contains the horizontal or vertical position of where the scroll operation starts.
						$iDX = DllStructGetData($tNMLVSCROLL, 'DX')
						$iDY = DllStructGetData($tNMLVSCROLL, 'DY')
						If $iDX Or $iDY Then
							$sColor = '>'
							_SetEditPos($g_aRect)
							If Not $g_bRECT_OUT_OF_RANGE Then
								$g_bRedrawFrameRect = True
;~ 								_FrameRect($g_hDC, $aRect, $g_hBrush)
							EndIf
						Else
							$sColor = '!'
						EndIf
						_DebugPrint($sColor  & ' WM_NOTIFY $LVN_ENDSCROLL   $iTopIndex: ' & $iTopIndex & ' $iCounterPage: ' & $iCounterPage & ' $iDX: ' & $iDX & ' $iDY: ' & $iDY & _
								' $g_iItem: ' & $g_iItem & ' $g_iSubItem: ' & $g_iSubItem & ' (' & $g_iItem - $iDY & ')' & _
								' $g_aRect: ' & _NumArrayOrStructToStrFormat($g_aRect) & ' $g_bEditMode: ' & $g_bEditMode & @CRLF)
					EndIf
					; Return value not used.
				Case $LVN_KEYDOWN        ; -155 A key has been pressed
					Local $tNMLVKEYDOWN = DllStructCreate($tagNMLVKEYDOWN, $lParam)
;~ 					Local $tNMLVKEYDOWN = DllStructCreate($tagFIXEDNMLVKEYDOWN, $lParam) ; Benutzen, wenn $tagNMLVKEYDOWN Probleme macht!
					_DebugPrint("WM_NOTIFY $LVN_KEYDOWN" & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode & @CRLF & _
							"--> VKey    : " & DllStructGetData($tNMLVKEYDOWN, "VKey") & @CRLF & _
							"--> Flags   : " & DllStructGetData($tNMLVKEYDOWN, "Flags"))
					; No return value
				Case $LVN_HOTTRACK       ; -121
;~ 					_DebugPrint('- WM_NOTIFY $g_hListView: Case $LVN_HOTTRACK' & @CRLF)
				Case $NM_CUSTOMDRAW      ; -12
;~ 					_DebugPrint('! WM_NOTIFY $NM_CUSTOMDRAW' & @CRLF)
					Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
					Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
					Local $aRect = [DllStructGetData($tNMLVCUSTOMDRAW, "Left"), DllStructGetData($tNMLVCUSTOMDRAW, "Top"), DllStructGetData($tNMLVCUSTOMDRAW, "Right"), DllStructGetData($tNMLVCUSTOMDRAW, "Bottom")]

					; $aRect2 ist immer [0, 0, 0, 0] !?
;~ 					Local $iTextLeft   = DllStructGetData($tNMLVCUSTOMDRAW, 'TextLeft')
;~ 					Local $iTextTop    = DllStructGetData($tNMLVCUSTOMDRAW, 'TextTop')
;~ 					Local $iTextRight  = DllStructGetData($tNMLVCUSTOMDRAW, 'TextRight')
;~ 					Local $iTextBottom = DllStructGetData($tNMLVCUSTOMDRAW, 'TextBottom')
;~ 					Local $aRect2 = [$iTextLeft, $iTextTop, $iTextRight, $iTextBottom]
;~ 					_DebugPrint('> $aRect2: ' & _NumArrayOrStructToStrFormat($aRect2) & @CRLF)

					Switch $dwDrawStage ; Holds a value that specifies the drawing stage
						Case $CDDS_PREPAINT ; Before the paint cycle begins
							Return $CDRF_NOTIFYITEMDRAW ; Notify the parent window of any ITEM-related drawing operations
						Case $CDDS_ITEMPREPAINT ; Before painting an item
							Return $CDRF_NOTIFYSUBITEMDRAW ; Notify the parent window of any SUBITEM-related drawing operations
						Case BitOR($CDDS_ITEMPREPAINT, $CDDS_SUBITEM) ; Before painting a subitem
							Local $dwItemSpec = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec") ; Item index
							Local $iSubItem = DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem") ; Subitem index
							Local $uItemState = DllStructGetData($tNMLVCUSTOMDRAW, "uItemState") ; Item state

							Local $sColor, $iColor, $iBkColor

							If ($dwItemSpec = $g_iItem) And ($iSubItem = $g_iSubItem) And $g_bEditMode Then
								; Verhält sich anders als $g_hDC und die Position beim letzten (rechten) SubItem stimmt nicht mit diesem DC!
;~ 								Local $hDC = DllStructGetData($tNMLVCUSTOMDRAW, "hDC")
;~ 								If _FrameRect($hDC, $aRect, $g_hBrush) Then
								If _FrameRect($g_hDC, $aRect, $g_hBrush) Then
									_DebugPrint('! WM_NOTIFY $NM_CUSTOMDRAW $g_bEditMode: True Return $GUI_RUNDEFMSG  $g_hBrush: ' & ($g_hBrush = $g_hBrush1 ? '$g_hBrush1' : '$g_hBrush2') & @CRLF)
;~ 									ConsoleWrite('! WM_NOTIFY $NM_CUSTOMDRAW $g_bEditMode: True Return $GUI_RUNDEFMSG  $g_hBrush: ' & ($g_hBrush = $g_hBrush1 ? '$g_hBrush1' : '$g_hBrush2') & @CRLF)
;~ 									Return $CDRF_SKIPDEFAULT
									Return $GUI_RUNDEFMSG
								EndIf
							EndIf

							If BitAND($uItemState, $CDIS_FOCUS) Then
								If BitAND($uItemState, $CDIS_HOT) Then
									$sColor = '>'
									$iColor = 0x000000
									$iBkColor = 0xD0FF00
								Else
									$sColor = '!'
									$iColor = 0xFFFFFF
									Switch $iSubItem
										Case 0
											$iBkColor = 0xCC6600
										Case 1
											$iBkColor = 0x66CC00
										Case 2
											$iBkColor = 0x6600CC
										Case 3
											$iBkColor = 0x0066CC
									EndSwitch
								EndIf
							Else
								$sColor = '+'
								$iColor = 0x00FF00
								Switch $iSubItem
									Case 0
										$iBkColor = 0x660000
									Case 1
										$iBkColor = 0x006600
									Case 2
										$iBkColor = 0x000066
									Case 3
										$iBkColor = 0x660066
								EndSwitch
							EndIf

							DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", $iColor) ; Forecolor
							DllStructSetData($tNMLVCUSTOMDRAW, "clrTextBk", $iBkColor) ; Backcolor

							_DebugPrint(StringFormat('%s WM_NOTIFY $NM_CUSTOMDRAW $dwItemSpec: %2i $iSubItem: %2i $g_iItem: %2i $g_iSubItem: %2i FOCUS: %2i HOT: %2i MARKED: %2i SELECTED: %2i $aRect: %s $iColor: 0x%s $iBkColor: 0x%s\n', _
								$sColor, $dwItemSpec, $iSubItem, $g_iItem, $g_iSubItem, BitAND($uItemState, $CDIS_FOCUS), BitAND($uItemState, $CDIS_HOT), BitAND($uItemState, $CDIS_MARKED), BitAND($uItemState, $CDIS_SELECTED), _NumArrayOrStructToStrFormat($aRect), Hex($iColor, 6), Hex($iBkColor, 6)))

							Return $CDRF_NEWFONT ; $CDRF_NEWFONT must be returned after changing font or colors
					EndSwitch

				Case $NM_RELEASEDCAPTURE ; -16 Notifies a control's parent window that the control is releasing mouse capture.
;~ 					_DebugPrint('! WM_NOTIFY $g_hListView: Case $NM_RELEASEDCAPTURE' & ' Focus: ' & ControlGetFocus($g_hGUI) & @CRLF)
					; Unless otherwise specified, the control ignores the return value from this notification code.
				Case $NM_CLICK           ; -2
					Local $tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					_DebugPrint("WM_NOTIFY $NM_CLICK ($tagNMITEMACTIVATE)" & @CRLF & _
							"--> Focus   : " & ControlGetFocus($g_hGUI) & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode & @CRLF & _
							"--> Index   : " & DllStructGetData($tNMITEMACTIVATE, "Index") & @CRLF & _
							"--> SubItem : " & DllStructGetData($tNMITEMACTIVATE, "SubItem") & @CRLF & _
							"--> NewState: " & DllStructGetData($tNMITEMACTIVATE, "NewState") & @CRLF & _
							"--> OldState: " & DllStructGetData($tNMITEMACTIVATE, "OldState") & @CRLF & _
							"--> Changed : " & DllStructGetData($tNMITEMACTIVATE, "Changed") & @CRLF & _
							"--> ActionX : " & DllStructGetData($tNMITEMACTIVATE, "X") & @CRLF & _ ; Hier wird in der AutoIt-Hilfe anstelle "X" fälschlicherweise "ActionX" verwendet
							"--> ActionY : " & DllStructGetData($tNMITEMACTIVATE, "Y") & @CRLF & _ ; Hier wird in der AutoIt-Hilfe anstelle "Y" fälschlicherweise "ActionY" verwendet
							"--> lParam  : " & DllStructGetData($tNMITEMACTIVATE, "lParam") & @CRLF & _
							"--> KeyFlags: " & DllStructGetData($tNMITEMACTIVATE, "KeyFlags"))

					If $g_iItem > -1 Then _GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
					$g_iItem = DllStructGetData($tNMITEMACTIVATE, "Index")
					$g_iSubItem = DllStructGetData($tNMITEMACTIVATE, "SubItem")
					_GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
					If $g_iItem > -1 Then
;~ 						$g_aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
						$g_aRect = _GetEditRect($g_iItem, $g_iSubItem)
					EndIf
				Case $NM_DBLCLK          ; -3 Sent by a list-view control when the user double-clicks an item with the left mouse button. (used for item and subitem edit)
					; lParam
					; Version 4.71. Pointer to an NMITEMACTIVATE structure that contains additional information about this notification. The iItem, iSubItem, and ptAction members of this structure contain information about the item.
					; The iItem member of lParam is only valid if the icon or first-column label has been clicked. To determine which item is selected when a click takes place elsewhere in a row, send an LVM_SUBITEMHITTEST message.
					Local $tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					_DebugPrint("WM_NOTIFY $NM_DBLCLK ($tagNMITEMACTIVATE)" & @CRLF & _
							"--> Focus   : " & ControlGetFocus($g_hGUI) & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode & @CRLF & _
							"--> Index   : " & DllStructGetData($tNMITEMACTIVATE, "Index") & @CRLF & _
							"--> SubItem : " & DllStructGetData($tNMITEMACTIVATE, "SubItem") & @CRLF & _
							"--> NewState: " & DllStructGetData($tNMITEMACTIVATE, "NewState") & @CRLF & _
							"--> OldState: " & DllStructGetData($tNMITEMACTIVATE, "OldState") & @CRLF & _
							"--> Changed : " & DllStructGetData($tNMITEMACTIVATE, "Changed") & @CRLF & _
							"--> ActionX : " & DllStructGetData($tNMITEMACTIVATE, "X") & @CRLF & _ ; Hier wird in der AutoIt-Hilfe anstelle "X" fälschlicherweise "ActionX" verwendet
							"--> ActionY : " & DllStructGetData($tNMITEMACTIVATE, "Y") & @CRLF & _ ; Hier wird in der AutoIt-Hilfe anstelle "Y" fälschlicherweise "ActionY" verwendet
							"--> lParam  : " & DllStructGetData($tNMITEMACTIVATE, "lParam") & @CRLF & _
							"--> KeyFlags: " & DllStructGetData($tNMITEMACTIVATE, "KeyFlags"))

					If $g_iItem > -1 Then _GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
					$g_iItem = DllStructGetData($tNMITEMACTIVATE, "Index")
					$g_iSubItem = DllStructGetData($tNMITEMACTIVATE, "SubItem")
					_SwitchEditState($g_iItem > -1 ? True : False)
					If $g_iItem > -1 Then
						_GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
						$g_aRect = _GetEditRect($g_iItem, $g_iSubItem)
						_FrameRect($g_hDC, $g_aRect, $g_hBrush2)
					EndIf
					_DebugPrint('! $tagNMITEMACTIVATE: ' & $tagNMITEMACTIVATE & @CRLF)
					_DebugPrint('> WM_NOTIFY $g_hListView: $g_iItem: ' & $g_iItem & ' $g_iSubItem: ' & $g_iSubItem & ' $g_bEditMode: ' & $g_bEditMode & @CRLF)
					; Return value not used.
				Case $NM_RETURN          ; -4 The control has the input focus and that the user has pressed the ENTER key <<== It does not work!!!
					_DebugPrint("WM_NOTIFY $NM_RETURN" & @CRLF & _
							"--> hWndFrom: " & $hWndFrom & @CRLF & _
							"--> IDFrom  : " & $iIDFrom & @CRLF & _
							"--> Code    : " & $iCode)
					; No return value
				Case $NM_SETFOCUS        ; -7
;~ 					_DebugPrint('- WM_NOTIFY $g_hListView: Case $NM_SETFOCUS' & @CRLF)
				Case $NM_KILLFOCUS       ; -8
;~ 					_DebugPrint('- WM_NOTIFY $g_hListView: Case $NM_KILLFOCUS' & @CRLF)
				Case $NM_RELEASEDCAPTURE ; -16 Notifies a list-view control's parent window that the control is releasing mouse capture.
					; The control ignores the return value from this notification code.
				Case Else
					_DebugPrint('- WM_NOTIFY $g_hListView: $iCode        : ' & $iCode & @CRLF)
			EndSwitch
		Case $g_hEdit
			_DebugPrint('> WM_NOTIFY $g_hEdit: $iCode: ' & $iCode & @CRLF)
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY
#Tidy_On

Func _SwitchEditState($bState, $sLine = @ScriptLineNumber)
	_DebugPrint('> _SwitchEditState('&$bState&') $sLine: ' & $sLine & @CRLF)
	If $g_bEditMode = $bState Then Return

	$g_bEditMode = $bState

	If $g_bEditMode Then
;~ 		Local $aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
		Local $aRect = _GetEditRect($g_iItem, $g_iSubItem)
		_SetEditPos($aRect)
		GUICtrlSetState($g_idEdit, BitOR($GUI_SHOW, $GUI_FOCUS))
		_GUICtrlEdit_SetText($g_hEdit, _GUICtrlListView_GetItemText($g_hListView, $g_iItem, $g_iSubItem))
	Else
		_GUICtrlEdit_SetText($g_hEdit, '')
		GUICtrlSetState($g_idEdit, BitOR($GUI_HIDE, $GUI_NOFOCUS))
		_GUICtrlListView_RedrawItems($g_hListView, $g_iItem -1, $g_iItem +1)
	EndIf
EndFunc   ;==>_SwitchEditState

Func _SetEditPos($aRect)
	If $aRect[1] < $g_aHeaderRect[3] Or $aRect[1] > $g_aLV_ClientSize[1] Then
		$g_bRECT_OUT_OF_RANGE = True
		GUICtrlSetPos($g_idEdit, 0, - 100)
		_DebugPrint('> _WinAPI_RedrawWindow($g_hHeader)' & @CRLF)
		_WinAPI_RedrawWindow($g_hHeader)
	Else
		$g_bRECT_OUT_OF_RANGE = False
		GUICtrlSetPos($g_idEdit, $aRect[0] +1, $aRect[1] +0, $aRect[2] - $aRect[0] -1, $aRect[3] - $aRect[1] -1)
;~ 		GUICtrlSetPos($g_idEdit, $aRect[0] +3, $aRect[1] +3, $aRect[2] - $aRect[0] -3, $aRect[3] - $aRect[1] -5)
	EndIf
EndFunc

Func _GetEditRect($iItem, $iSubItem)
	Local $aRect = $iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $iItem, $iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $iItem, 2)
	If $iSubItem > 0 Then
		Local $aIconRect = _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem, 1)
		$aRect[0] += ($aIconRect[2] - $aIconRect[0])
;~ 		_DebugPrint('> $aIconRect[2] - $aIconRect[0]: ' & $aIconRect[2] - $aIconRect[0] & ' $aRect[0]: ' & $aRect[0] & ' $aRect[0] += ($aIconRect[2] - $aIconRect[0]): ' & $aRect[0] + ($aIconRect[2] - $aIconRect[0]) & @CRLF)
	EndIf
	Return $aRect
EndFunc


Func _FrameRect($hDC, $aRect, $hBrush)
	; $aRect Item    = 4, 24, 78, 46
	; $aRect SubItem = 78, 24, 181, 46

	If $aRect[1] < $g_aHeaderRect[3] Or $aRect[1] > $g_aLV_ClientSize[1] Then
		$g_bRECT_OUT_OF_RANGE = True
		Return False
	Else
		$g_bRECT_OUT_OF_RANGE = False
	EndIf

	Local $tRect = DllStructCreate($tagRECT), $sDC, $sBrush = $hBrush = $g_hBrush1 ? '$g_hBrush1' : '$g_hBrush2'

	If $hDC = $g_hDC Then
;~ 		Return
		$sDC = 'Global        '
		$aRect = _GetEditRect($g_iItem, $g_iSubItem)
;~ 		$aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
		DllStructSetData($tRect, 'Left',  $aRect[0] - 0)
		DllStructSetData($tRect, 'Top',   $aRect[1] - 1)
		DllStructSetData($tRect, 'Right', $aRect[2] + 1)
		DllStructSetData($tRect, 'Bottom',$aRect[3] + 0)
	Else
		$sDC = '$NM_CUSTOMDRAW'
		DllStructSetData($tRect, 'Left',  $aRect[0] - 0)
		DllStructSetData($tRect, 'Top',   $aRect[1] - 1)
		DllStructSetData($tRect, 'Right', $aRect[2] + 2)
		DllStructSetData($tRect, 'Bottom',$aRect[3] + 1)
	EndIf

	Local $aRes = DllCall("user32.dll", "int", "FrameRect", "hwnd", $hDC, "ptr", DllStructGetPtr($tRect), "hwnd", $g_hBrush)
;~ 	ConsoleWrite(StringFormat('> _FrameRect: $hDC: %s (%s)  $aRect: %s  $tRect: %s  $g_aLV_ClientSize: %s  $hBrush: %s (%s)  @error: %i  $aRes[0]: %i\n', _
	_DebugPrint(StringFormat('> _FrameRect: $hDC: %s (%s)  $aRect: %s  $tRect: %s  $g_aLV_ClientSize: %s  $hBrush: %s (%s)  @error: %i  $aRes[0]: %i\n', _
		$hDC, $sDC, _NumArrayOrStructToStrFormat($aRect), _NumArrayOrStructToStrFormat($tRect), _NumArrayOrStructToStrFormat($g_aLV_ClientSize), $hBrush, $sBrush, @error, $aRes[0]))
	Return True
EndFunc   ;==>_FrameRect

Func _RedrawFrameRect($hWnd, $iMsg, $iIDtimer, $iTime)
	#forceref $hWnd, $iMsg, $iIDTimer,$iTime
	If $g_bRedrawFrameRect Then ; $LVN_ENDSCROLL
		$g_bRedrawFrameRect = False
;~ 		Local $aRect = $g_iSubItem > 0 ? _GUICtrlListView_GetSubItemRect($g_hListView, $g_iItem, $g_iSubItem) : _GUICtrlListView_GetItemRect($g_hListView, $g_iItem, 2)
		Local $aRect = _GetEditRect($g_iItem, $g_iSubItem)
		If $aRect[1] > $g_aHeaderRect[3] Then _WinAPI_RedrawWindow($g_hHeader)
		_DebugPrint('> _RedrawFrameRect ' & _NumArrayOrStructToStrFormat($aRect) & @CRLF)
;~ 		_FrameRect($g_hDC, $g_aRect, $g_hBrush)
		_FrameRect($g_hDC, $aRect, $g_hBrush)
	EndIf
EndFunc

Func _DebugPrint($s_Text, $sLine = @ScriptLineNumber)
	If Not $g_bDebug Then Return

	If StringRegExp(StringLeft($s_Text, 1), '+|-|>|!') Then
		ConsoleWrite($s_Text)
	Else
		ConsoleWrite( _
				"!===========================================================" & @CRLF & _
				"+======================================================" & @CRLF & _
				"@@ Line(" & StringFormat("%d", $sLine) & ") :" & @TAB & $s_Text & @CRLF & _
				"+======================================================" & @CRLF)
	EndIf
EndFunc   ;==>_DebugPrint

Func _NumArrayOrStructToStrFormat($vNumStr, $iAlign = 4)
	If IsDllStruct($vNumStr) Then
		Local $iNum, $aNum[0], $t = 1
		While 1
			$iNum = DllStructGetData($vNumStr, $t)
			If @error Then ExitLoop
			_ArrayAdd($aNum, StringFormat('%' & $iAlign & 'i', $iNum))
			$t += 1
		WEnd
		Return '[' & _ArrayToString($aNum, ', ') & ']'
	EndIf

	For $i = 0 To UBound($vNumStr) - 1 Step 1
		$vNumStr[$i] = StringFormat('%' & $iAlign & 'i', $vNumStr[$i])
	Next
	Return '[' & _ArrayToString($vNumStr, ', ') & ']'
EndFunc   ;==>_NumArrayOrStructToStrFormat

Func _GetItemStateStr($iItemState)
	Local Static $aStates = [[$CDIS_SELECTED, '$CDIS_SELECTED'], [$CDIS_GRAYED, '$CDIS_GRAYED'], [$CDIS_DISABLED, '$CDIS_DISABLED'], [$CDIS_CHECKED, '$CDIS_CHECKED'], [$CDIS_FOCUS, '$CDIS_FOCUS'], [$CDIS_DEFAULT, '$CDIS_DEFAULT'], [$CDIS_HOT, '$CDIS_HOT'], [$CDIS_MARKED, '$CDIS_MARKED'], [$CDIS_INDETERMINATE, '$CDIS_INDETERMINATE'], [$CDIS_SHOWKEYBOARDCUES, '$CDIS_SHOWKEYBOARDCUES'], [$CDIS_NEARHOT, '$CDIS_NEARHOT'], [$CDIS_OTHERSIDEHOT, '$CDIS_OTHERSIDEHOT'], [$CDIS_DROPHILITED, '$CDIS_DROPHILITED']]

	Local $sItemState
	For $i = 0 To 12 Step 1
		If BitAND($iItemState, $aStates[$i][0]) = $aStates[$i][0] Then $sItemState &= $aStates[$i][1] & ', '
	Next
	Return '(' & StringTrimRight($sItemState, 2) & ')'
EndFunc
